import React, { Component } from 'react';
import PropTypes from 'prop-types';

var classCallCheck = function (instance, Constructor) {
  if (!(instance instanceof Constructor)) {
    throw new TypeError("Cannot call a class as a function");
  }
};

var createClass = function () {
  function defineProperties(target, props) {
    for (var i = 0; i < props.length; i++) {
      var descriptor = props[i];
      descriptor.enumerable = descriptor.enumerable || false;
      descriptor.configurable = true;
      if ("value" in descriptor) descriptor.writable = true;
      Object.defineProperty(target, descriptor.key, descriptor);
    }
  }

  return function (Constructor, protoProps, staticProps) {
    if (protoProps) defineProperties(Constructor.prototype, protoProps);
    if (staticProps) defineProperties(Constructor, staticProps);
    return Constructor;
  };
}();

var inherits = function (subClass, superClass) {
  if (typeof superClass !== "function" && superClass !== null) {
    throw new TypeError("Super expression must either be null or a function, not " + typeof superClass);
  }

  subClass.prototype = Object.create(superClass && superClass.prototype, {
    constructor: {
      value: subClass,
      enumerable: false,
      writable: true,
      configurable: true
    }
  });
  if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass;
};

var possibleConstructorReturn = function (self, call) {
  if (!self) {
    throw new ReferenceError("this hasn't been initialised - super() hasn't been called");
  }

  return call && (typeof call === "object" || typeof call === "function") ? call : self;
};

var ReactImageTooltip = function (_Component) {
  inherits(ReactImageTooltip, _Component);

  function ReactImageTooltip() {
    var _ref;

    var _temp, _this, _ret;

    classCallCheck(this, ReactImageTooltip);

    for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    return _ret = (_temp = (_this = possibleConstructorReturn(this, (_ref = ReactImageTooltip.__proto__ || Object.getPrototypeOf(ReactImageTooltip)).call.apply(_ref, [this].concat(args))), _this), _this.state = {
      display: false,
      mouseX: 0,
      mouseY: 0
    }, _this.toogleImage = function () {
      _this.setState({
        display: !_this.state.display
      });
    }, _this.handleMouseOver = function (event) {
      console.log(event.clientX);
      _this.setState({
        mouseX: event.clientX,
        mouseY: event.clientY
      });
    }, _temp), possibleConstructorReturn(_this, _ret);
  }

  createClass(ReactImageTooltip, [{
    key: "render",
    value: function render() {
      var _this2 = this;

      var _props = this.props,
          children = _props.children,
          image = _props.image;


      var childrenStyles = {
        display: "inline-block",
        position: "relative",
        zIndex: 1
      };

      var imageStyles = {
        top: this.state.mouseY - 50 + "px",
        left: this.state.mouseX - 50 + "px",
        width: this.props.width ? this.props.width + "px" : "300px",
        height: this.props.height ? this.props.height + "px" : "100%",
        pointerEvents: "none",
        position: "fixed",
        background: "url(" + this.props.image + ")",
        backgroundSize: "contain",
        backgroundRepeat: "no-repeat",
        zIndex: 0
      };

      return image ? React.createElement(
        "span",
        {
          onMouseEnter: this.toogleImage,
          onMouseLeave: this.toogleImage,
          onMouseMoveCapture: this.handleMouseOver,
          onTouchStart: function onTouchStart() {
            return _this2.setState({ display: false });
          }
        },
        React.createElement(
          "span",
          { style: this.state.display ? childrenStyles : null },
          children
        ),
        this.state.display && React.createElement("span", { style: imageStyles })
      ) : children;
    }
  }]);
  return ReactImageTooltip;
}(Component);

ReactImageTooltip.propTypes = {
  children: PropTypes.object.isRequired,
  image: PropTypes.string.isRequired,
  width: PropTypes.number,
  height: PropTypes.number
};

export default ReactImageTooltip;
//# sourceMappingURL=index.es.js.map
